#!/bin/sh
# GB_Import.sh v1.1
# Auteur : Michel Wurtz/Sylvain Perrinel
# Description : script d'importation des donnes des autres GoBASEs
# et de la BDNT -  voir gb_echange.doc pour les spcifications techniques

# Evitons les messages intempestifs
exec >/dev/null 2>&1

# Qui suis-je ?
url=`uname -n`
web=`echo $url | sed 's/linda/geomap/'`
ip=`host $url | sed -e 's/^.* 10\./10\./'`

# Calcul du dlai pour viter la superposition des requtes
ip2=`host $url | sed -e 's/^.* 10\.//' -e 's/\..*$//'`
jour=`date +%j`
delai=`expr '(' '(' $ip2 + '(' 29 '*' $jour ')' ')' '%' 100 ')' '*' 60`
sleep $delai

# On s'occupe d'abord des autres serveurs LINDA ce qui permet
# d'ajouter un ala supplmentaire au dlai pour la BDNT.

# Paramtrage global
PGPORT=5432
PGBASE=geomap_admin
PGSCHM=gb_echange

# Lecture de la table gb_import
sudo -u postgres psql -d $PGBASE -p $PGPORT -c "select * from $PGSCHM.gb_import" | grep -v '(' | sed -e '1,2d' -e 's/ *//g' -e 's/|/\t/g' | while read nom serveur date md5tab md5map md5dat archiver lien log
do
	if [ -z "$nom" ]
	then
		continue
	fi

	# On vrifie que le fichier  rcuprer
	# - soit n'existe pas dans COUGRA.XML
	# - soit est uniquement en base de CONSULTATION

	ligne=`grep -i $nom /geobase/REF_EXT/COUGRA.XML | sed -e 's/.*CHDESC_LB="//' -e 's/" CHEMIN_LB="/ /' -e 's/".*//' -e 's/\\\\/\\//g' `
	if [ -z "$ligne" ]
	then
		# la ligne n'existe pas
		acreer=oui
	else
		# est-on bien dans la base de consultation
		if expr "$ligne" : 'C.*'
		then
			acreer=non
			chemin=`echo $ligne | sed 's/.* //'`
			ch=/geobase/CONSULTATION/$chemin
		else
			echo "La couche $nom n'est pas en base de CONSULTATION" >&2
			continue
		fi
	fi
	# rcupration du nom de l'archive ou d'un message d'erreur
	newlien=`echo ${lien} | sed s/linda/geomap/g`
	rep=`wget -O - "http://$newlien/get_export.php?c=$nom&s=$ip&d=$date&md5tab=$md5tab&md5map=$md5map&md5dat=$md5dat&acreer=$acreer"`
	case $rep in
		noperm) echo "Permission refuse : $nom ($serveur)" >&2
			resImport="Permission refusee"
			sudo -u postgres psql -d $PGBASE -p $PGPORT -c "update $PGSCHM.gb_import set log_import='$resImport'  where nom_couche='$nom'"
			continue ;;
		nolayer) echo "Couche $nom non prsente dans la GoBASE du serveur ($serveur)" >&2
			resImport="Pas de couche"
			sudo -u postgres psql -d $PGBASE -p $PGPORT -c "update $PGSCHM.gb_import set log_import='$resImport'  where nom_couche='$nom'"
			continue ;;
		ajour)	resImport="Couche a jour"
			sudo -u postgres psql -d $PGBASE -p $PGPORT -c "update $PGSCHM.gb_import set log_import='$resImport'  where nom_couche='$nom'"
			continue ;;
		*.ZIP)	;;
		*) 	resImport="Erreur du serveur"
			sudo -u postgres psql -d $PGBASE -p $PGPORT -c "update $PGSCHM.gb_import set log_import='$resImport'  where nom_couche='$nom'"
			echo "Erreur serveur : $rep" >&2 ; continue ;;
	esac
	wget "http://$newlien/tmp/$rep" -O /tmp/$rep
	# on extrait les fichiers en temporaire...
        unzip -q -o -d /tmp /tmp/$rep
	rm /tmp/$rep
	#On archive dans la GoBASE s'il le faut
	if [ "$archiver" = "t" -a "$acreer" = "non" ]
	then
		# on archive le fichier existant...
		# recherche des fichiers existants et calcul de l'extension
		ext=0`ls $ch | grep "$nom.*TAB" | sed -e "s/$nom//" -e "s/.TAB//" -e 's/_//' | sort | tail -1`
		ext=`expr $ext + 1`
		ext=`echo 0000$ext | sed 's/^.*\(....\)$/\1/'`
		# \. car on ne veut pas les fichiers dj historiss
		for f in `ls $ch | grep "$nom\."`
		do
			mv $ch/$f `echo $ch/$f | sed "s/$nom/&_$ext/"`
		done
	fi
	if [ "$acreer" = "oui" ]
	then
		# on cre l'entre dans COUGRA.XML
		# extraction de l'entre pour COUGRA
		echo 'rien'
		#on lance GB_Verif.pl  la fin qui mettra comme il faut l'entre dans le COUGRA
	fi
	# on dplace la couche au bon endroit
	txt=`echo $rep | sed 's/\.ZIP//'`
	ch=`cat /tmp/$txt.txt`
	rm /tmp/$txt.txt
	mv /tmp/$nom.* $ch/
	# et on met  jour la base de donnes
	md5tab=`md5sum $ch/$nom.TAB | sed 's/ .*$//'`
	md5dat=`md5sum $ch/$nom.DAT | sed 's/ .*$//'`
	md5map=`md5sum $ch/$nom.MAP | sed 's/ .*$//'`
	resImport="Oki"
	sudo -u postgres psql -d $PGBASE -p $PGPORT -c "update $PGSCHM.gb_import set date_import=now(), md5_tab='$md5tab', md5_map='$md5map', md5_dat='$md5dat', log_import='$resImport'  where nom_couche='$nom'"

	# on avertit le serveur que c'est fini
	wget -O /dev/null "http://$newlien/clean_export.php?f=$rep" 
	# On met  jour le COUGRA comme il faut
	perl /usr/lib/geobase/GB_Verif.pl
done
# On s'occupe ensuite de la BDNT
# @@@@@@@@@@@@ TODO

####################   Changelog

# 2008-03-12 Sylvain Perrinel v1.1
# - Ajout de exec >/dev/null 2>&1 pour viter les mails a l'utilisateur GoMAP
