#!/bin/bash

GEOIDE_FTP_SERVER=app-ftp17.sen.centre-serveur.i2
LOGDIR=%%geobase_log

script=`pwd`
ftpuser=%%geoide_base_replic_ftp_user
ftppassword=%%geoide_base_replic_ftp_pass
serialnb=%%geoide_base_replic_sn

# chemin à vérifier
cd %%geobase_homedir

# Evitons les messages intempestifs
exec >/dev/null 2>&1

# déclenchement échelonné de 150 sites toutes les 120 secondes
day=`date +%j`
delay=`expr '(' '(' $serialnb + '(' 29 '*' $day ')' ')' '%' 150 ')' '*' 120`
sleep $delay

du -h --max-depth 1 /geobase >  $LOGDIR/repli.STATS.log
date >> $LOGDIR/repli.STATS.log
nohup lftp -e "mirror -R -v -X LOCAL/* -X *.old -X *.OLD PRODUCTION" -u $ftpuser,$ftppassword $GEOIDE_FTP_SERVER 2>&1 > $LOGDIR/repli.PROD.log
date >> $LOGDIR/repli.STATS.log
nohup lftp -e "mirror -R -v -X LOCAL/* -X *.old -X *.OLD CONSULTATION" -u $ftpuser,$ftppassword $GEOIDE_FTP_SERVER 2>&1 > $LOGDIR/repli.CONS.log
date >> $LOGDIR/repli.STATS.log
