#!/bin/sh
# Auteur : Sylvain Perrinel
# Date : 04/09/2008
# Script de conversion Tif -> Ecw

if [ $# -lt 2 ]; then
    echo "Usage: $0 <Repertoire Tif> <Repertoire de destination>"
    exit 1
fi

dossierOrig=$1
dossierDest=$2

mkdir $dossierDest 2>/dev/null

nbTraitement=`ls ${1}/*.tif ${1}/*.TIF | wc -l`

if [ $nbTraitement -gt 0 ] 
then
    i=0
    for fichier in `ls ${1}/*.tif ${1}/*.TIF`
    do
        i=$(($i+1))
        basename=`basename "$fichier"`
        echo "Traitement ($i/$nbTraitement) : $basename" 
        dirname=`dirname "$fichier"`
        nomFichier=${basename%.*}
        extFichier=${fichier%*.}
        pct2rgb.py $fichier $dossierDest/temp.tif
        gdal_translate -of ECW -co PROJ=LM2FRANC -co DATUM=NTF $dossierDest/temp.tif $dossierDest/$nomFichier.ECW
        rm $dossierDest/temp.tif 2>/dev/null
        cp $dossierOrig/$nomFichier.TAB $dossierDest/
        sed -i 's/${extFichier}/ECW/' $dossierDest/$nomFichier.TAB
    done
else
    echo 'Rien à faire ...'
fi
exit 0
